/*******************************************************************************//**
 * \file allo_transcode.h
 * \brief ALLO Transcoding library for Vocallo/ALLO Transcoding Board
 * \brief Provides User a Unified/OS Agnostic API to ALLO Transcoding Board
 *
 *
*/


struct ns1__allotc_codec_request_leg
{
	uint32_t 	codec_id;
	uint32_t	ms;

	uint32_t	host_ip;
	uint32_t	host_netmask;
	uint32_t	host_udp_port;

};


struct ns1__allotc_codec_reply_leg
{
	uint32_t	codec_ip;
	uint32_t	codec_netmask;
	uint32_t	codec_udp_port;

	uint32_t	host_ip;
	uint32_t	host_netmask;
	uint32_t	host_udp_port;

	uint32_t	iana_code;

};


struct ns1__allotc_codec_reply
{
	uint32_t 	codec_module_session_idx;
	uint32_t	codec_rtp_session_idx;

	struct ns1__allotc_codec_reply_leg a;
	struct ns1__allotc_codec_reply_leg b;

	void		*tx_fd;
	uint32_t	tx_iana;

	void		*rx_fd;
	uint32_t	rx_iana;

	int32_t		result;
};
 

struct ns1__allotc_codec_request
{
	void *usr_priv;
	uint64_t 	tag;

	uint8_t		rtcp_enable;

	struct ns1__allotc_codec_request_leg a;
	struct ns1__allotc_codec_request_leg b;

};

int ns1__allotc_create_transcoding_session (struct ns1__allotc_codec_request *codec_req, 
										   struct ns1__allotc_codec_reply *codec_reply);
int ns1__allotc_free_transcoding_session   (struct ns1__allotc_codec_reply *codec_reply, int *result); 
