/*
 * Copyright (C) 2010, Sangoma Technologies 
 *
 * Nenad Corbic <ncorbic@sangoma.com>
 *
 *
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contributors:
 * Moises Silva <moy@sangoma.com>
 * David Rokhvarg <davidr@sangoma.com>
 *
 *
 */
#ifndef __ALLOTC_SERVER_H__
#define __ALLOTC_SERVER_H__

// common configuration options & declarations (always include first)
#include "config.h"

// C language includes
#include <stdio.h>
#include <stdlib.h> // atoi, exit
#include <string.h>


#if PLATFORM(Windows)
#define snprintf _snprintf
#else
#include <signal.h>
#endif

// application includes
#include "Server.h" /* server_xxx functions */

#include "allo_tc/allo_tc.h"

#define SERVER_IP_SIZE 50
extern allotc_init_cfg_t g_init;
extern char allotc_server_ip_str[SERVER_IP_SIZE];
extern int allotc_server_port;
extern int allotc_cpu_high;
extern int allotc_cpu_low;

int allotc_parse_xml_config_file(char *file);
int log_printf(int level, char* fmt, ...);

#if 0
#define ALLOTC_PRINT(level,a,...) log_printf(level,a,##__VA_ARGS__)
#define ALLOTC_DEBUG(a,...) 		ALLOTC_PRINT(ALLOTC_LOGLEVEL_DEBUG,a,##__VA_ARGS__)
#define ALLOTC_WARN(a,...) 		ALLOTC_PRINT(ALLOTC_LOGLEVEL_WARN,a,##__VA_ARGS__)
#define ALLOTC_INFO(a,...) 		ALLOTC_PRINT(ALLOTC_LOGLEVEL_L_INFO,a,##__VA_ARGS__)
#define ALLOTC_STATS(a,...) 		ALLOTC_PRINT(ALLOTC_LOGLEVEL_STATS,a,##__VA_ARGS__)
#define ALLOTC_ERROR(a,...)		ALLOTC_PRINT(ALLOTC_LOGLEVEL_ERROR,a,##__VA_ARGS__)
#define ALLOTC_CRIT(a,...) 		ALLOTC_PRINT(ALLOTC_LOGLEVEL_CRIT,a,##__VA_ARGS__)
#define ALLOTC_RES(a,...) 		ALLOTC_PRINT(ALLOTC_LOGLEVEL_L_RES,a,##__VA_ARGS__)
#define ALLOTC_TEST(a,...)

#define ALLOTC_L_LOGLEVEL_DECODE(level) \
		((level==ALLOTC_LOGLEVEL_DEBUG) ? "ALLOTC_DEBUG" : \
		(level==ALLOTC_LOGLEVEL_WARN) ? "ALLOTC_WARN" : \
		(level==ALLOTC_LOGLEVEL_INFO) ? "ALLOTC_INFO" : \
		(level==ALLOTC_LOGLEVEL_L_INFO) ? "ALLOTC_INFO" : \
		(level==ALLOTC_LOGLEVEL_L_RES) ? "ALLOTC_RESLT" : \
		(level==ALLOTC_LOGLEVEL_STATS) ? "ALLOTC_STATS" : \
		(level==ALLOTC_LOGLEVEL_ERROR) ? "ALLOTC_ERROR" : \
		(level==ALLOTC_LOGLEVEL_CRIT) ? "ALLOTC_CRIT" : "Unknown")        
#endif

#define TS2_LOGLEVEL_DECODE(level) \
		((level==LOG_LEVEL_FATAL) ? "LOG_LEVEL_FATAL" : \
		 (level==LOG_LEVEL_ERROR) ? "LOG_LEVEL_ERROR" : \
		 (level==LOG_LEVEL_WARN) ? "LOG_LEVEL_WARN" : \
		 (level==LOG_LEVEL_INFO) ? "LOG_LEVEL_INFO" : \
		 (level==LOG_LEVEL_DEBUG) ? "LOG_LEVEL_DEBUG" : \
		 (level==LOG_LEVEL_TRACE) ? "LOG_LEVEL_TRACE" :  "Unknown")

#endif

